
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>python变量交换性能优化 / 憋错料</title>

    <meta name="description" content="python变量交换性能优化 从多方面新讲python性能优化看到交换两个变量的值可以使用 a,b = b,a 这样可以提高性能 &gt;&gt;&gt; from timeit import Timer &gt;&gt;&gt; Timer(&quot;t=a;a=b;b=t&quot;,&quot;a=1;b=2&quot;).timeit() 0.06279781319366587 &gt;&gt;&gt; Timer(&quot;a,b=b,a&quot;,&quot;a=1;b=2&quot;).timeit()  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">python变量交换性能优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>从<a href="http://developer.51cto.com/art/201207/349689_3.htm" rel="external nofollow noreferrer">多方面新讲python性能优化</a>看到交换两个变量的&#20540;可以使用</p>
<pre>a,b = b,a</pre>
<p>这样可以提高性能</p>
<pre>&gt;&gt;&gt; from timeit import Timer
&gt;&gt;&gt; Timer(&quot;t=a;a=b;b=t&quot;,&quot;a=1;b=2&quot;).timeit()
0.06279781319366587
&gt;&gt;&gt; Timer(&quot;a,b=b,a&quot;,&quot;a=1;b=2&quot;).timeit()
0.0378979925538232
&gt;&gt;&gt;</pre>
<p>从运行时间上看，确实节省了快一半的时间</p>
<p>通过dis得到python字节码</p>
<pre>&gt;&gt;&gt; def func():
...     a,b = b,a
...
&gt;&gt;&gt; import dis
&gt;&gt;&gt; dis.dis(func)
  2           0 LOAD_FAST                0 (b)
              3 LOAD_FAST                1 (a)
              6 ROT_TWO
              7 STORE_FAST               1 (a)
             10 STORE_FAST               0 (b)
             13 LOAD_CONST               0 (None)
             16 RETURN_VALUE
&gt;&gt;&gt;</pre>
<p>可以看出主要是ROT_TWO指令的功劳：</p>
<p>查阅<a href="https://docs.python.org/2/library/dis.html" rel="external nofollow noreferrer">python文档</a>可以知道有ROT_TWO ROT_THREE ROT_FOUR这样的指令，可以直接交换两个变量、三个变量、四个变量的&#20540;</p>
<p>在python3.4的源码中查阅ceval.c文件可以看到：</p>
<pre>       TARGET(ROT_TWO) {
            PyObject *top = TOP();
            PyObject *second = SECOND();
            SET_TOP(second);
            SET_SECOND(top);
            FAST_DISPATCH();
        }

        TARGET(ROT_THREE) {
            PyObject *top = TOP();
            PyObject *second = SECOND();
            PyObject *third = THIRD();
            SET_TOP(second);
            SET_SECOND(third);
            SET_THIRD(top);
            FAST_DISPATCH();
        }</pre>
<p>就是这些指令的具体C语言实现了</p>
<p>归根究底，速度快还是因为a,b = b,a的方式全部是使用指针操作</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 19:25:49 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/python/" title="python">python</a>, <a href="https://www.biecuoliao.com/tag/c%e8%af%ad%e8%a8%80/" title="c语言">c语言</a>, <a href="https://www.biecuoliao.com/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.biecuoliao.com/tag/%e8%af%ad%e8%a8%80/" title="语言">语言</a>, <a href="https://www.biecuoliao.com/tag/%e6%80%a7%e8%83%bd%e4%bc%98%e5%8c%96/" title="性能优化">性能优化</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>python变量交换性能优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lXrqP0.html" rel="bookmark">Python 变量交换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 # coding = utf-8 2 3 a, b = 1, 2 4 print 'before change' 5 print a, b 6 7 a, b = b, a 8 print 'after change' 9 print a, b 10 11 #&gt;&gt;&gt; 12 #before change 13 #1 2 14 #after change 15 #2 1 理解第7行a, b = b, a是关键. 可以将b, a赋给一个变量c, 然后打印c出来,看看: 1 c = b, a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXq19X0.html" rel="bookmark">Python 代码性能优化技巧（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Python 代码性能优化技巧 Python 代码优化常见技巧 代码优化能够让程序运行更快,它是在不改变程序运行结果的情况下使得程序的运行效率更高,根据 80/20 原则,实现程序的重构.优化.扩展以及文档相关的事情通常需要消耗 80% 的工作量.优化通常包含两方面的内容:减小代码的体积,提高代码的运行效率. 改进算法,选择合适的数据结构 一个良好的算法能够对性能起到关键作用,因此性能改进的首要点是对算法的改进.在算法的时间复杂度排序上依次是: O(1) -&gt; O(lg n) -&gt; O(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myll5n4.html" rel="bookmark">&lbrack;转&rsqb; Python 代码性能优化技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				选择了脚本语言就要忍受其速度,这句话在某种程度上说明了 python 作为脚本的一个不足之处,那就是执行效率和性能不够理想,特别是在 performance 较差的机器上,因此有必要进行一定的代码优化来提高程序的执行效率.如何进行 Python 性能优化,是本文探讨的主要问题.本文会涉及常见的代码优化方法,性能优化工具的使用以及如何诊断代码的性能瓶颈等内容,希望可以给 Python 开发人员一定的参考. Python 代码优化常见技巧 代码优化能够让程序运行更快,它是在不改变程序运行结果的情况下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pqooRM.html" rel="bookmark">Python性能优化（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分成两部分:代码优化和工具优化 原文:http://my.oschina.net/xianggao/blog/102600 阅读 Zen of Python,在Python解析器中输入 import this. 一个犀利的Python新手可能会注意到&quot;解析&quot;一词, 认为Python不过是另一门脚本语言. &quot;它肯定很慢!&quot; 毫无疑问:Python程序没有编译型语言高效快速. 甚至Python拥护者们会告诉你Python不适合这些领域. 然而,YouTube已用Pyth			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz19R24.html" rel="bookmark">&lbrack;daily&rsqb;&lbrack;optimize&rsqb; 去吃面 （python类型转换函数引申的性能优化）（未完待续）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前天,20161012,到望京面试.第四个职位,终于进了二面.好么,结果人力安排完了面试时间竟然没有通知我,也没有收到短信邀请.如果没有短信邀请门口的保安大哥是不让我进去大厦的.然后,我在11号接到了面试官直接打来的电话,问我为啥还没到,我说没人通知我我不知道呀.结果我就直接被他邀请去以访客的身份参加面试了.不知道人力的姑娘是不是认识我,且和我有仇,终于可以报复了... 然后,我终于如约到了,面试官带着我去前台登记.前台的妹子更萌...认为我是面试官,面试官是才是来面试的.我气质真的那么合吗?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R7nzR3.html" rel="bookmark">python性能优化之列表生成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在看python算法时,发现简单的列表生成,不同的方式性能相差巨大,让我对性能优化有了很大兴趣.大家也来看一看平时有没有犯类似的错误呢. #!/usr/bin/env python import time def test1(n):     lst = []     for i in range(n*10000):         lst = lst + [i]     return lst def test2(n):     lst = []     for i in range(n*1000			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wj85V0.html" rel="bookmark">Spark性能优化&lpar;2&rpar;&mdash;&mdash;广播变量、本地缓存目录、RDD操作、数据倾斜</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				广播变量 背景 一般Task大小超过10K时(Spark官方建议是20K),需要考虑使用广播变量进行优化.大表小表Join,小表使用广播的方式,减少Join操作. 参考:Spark广播变量与累加器 Local Dir 背景 shuffle过程中,临时数据需要写入本地磁盘.本地磁盘的临时目录通过参数spark.local.dir配置. 性能优化点 spark.local.dir支持配置多个目录.配置spark.local.dir有多个目录,每个目录对应不同的磁盘,这样可以提升IO效率.另外,可以采			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9XlP4.html" rel="bookmark">Oracle 学习之性能优化（三）绑定变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				根据Oracle 学习之性能优化(二)游标中的描述,我们知道如下两条语句是不共享的. select * from emp where empno=7698; select * from emp where empno=7566; 这样就造成每次执行用户的查询都要进行硬解析,但是我们知道,其他这两个语句的执行计划应该是相同.那么有什么方法能避免不必要的硬解析吗?这里我们提供2种方法. 一.绑定变量 SQL&gt; variable empno number; SQL&gt; exec :empno := 7			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGxy2Q0.html" rel="bookmark">&lbrack;python&rsqb;用profile协助程序性能优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/gzlaiyonghao/article/details/1483728 本文最初发表于恋花蝶的博客http://blog.csdn.net/lanphaday,欢迎转载,但请务必保留原文完整,并保留本声明. [python]用profile协助程序性能优化 上帝说:“选择了脚本,就不要考虑性能.”我是很支持这句话的,使用脚本要的就是开发速度.良好的扩展性以及可维护性.可惜到了最后,我们的程序难免会运行得太慢,我们的客户不能忍受,这时候,我们就不得			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgKrgM.html" rel="bookmark" class="title">PAT天梯赛练习题 L3-010&period; 是否完全二叉搜索树（完全二叉树的判断）</a>
					<div>
						L3-010. 是否完全二叉搜索树 时间限制 400 ms 内存限制 65536 kB 代码长度限制 8000 B 判题程序 Standard 作者 陈越 将一系列给定数字顺序插入一个初始为空的二叉搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AJr5M.html" rel="bookmark" class="title">创建对象</a>
					<div>
						7种模式:工厂模式.构造函数模式.原型模式.组合使用构造函数模式和原型模式.动态原型模式.寄生构造函数模式.稳妥构造函数模式 1.工厂模式: 1 function createPerson(name, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bm2V4.html" rel="bookmark" class="title">python之basic加密http下载</a>
					<div>
						实例: import urllib2 import base64,logging def httpDownload(testModule,var): testModule = testModule + ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDNmzM.html" rel="bookmark" class="title">写一个程序输出1到100这些数字。但是遇到数字为3的倍数的时候，输出&OpenCurlyDoubleQuote;三&rdquo;替代数字，为5的倍数用&OpenCurlyDoubleQuote;五&rdquo;代替，既是3的倍数又是5的倍数则输出&OpenCurlyDoubleQuote;三五&rdquo;。</a>
					<div>
						1 &lt;!DOCTYPE html&gt; 2 &lt;html lang=&quot;en&quot;&gt; 3 &lt;head&gt; 4 &lt;meta charset=&quot;U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQlrq0.html" rel="bookmark" class="title">星际穿越 网易2017测试工程师编程题</a>
					<div>
						飞行器的损耗主要集中在发射和降落过程,科学家根据实验数据估计,如果在发射过程中,产生了x程度的损耗,那么在降落过程中会产生x2的损耗.问一艘耐久度为h的飞行器,假设在飞行过程中不产生损耗,为保证其可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWY6QG3.html" rel="bookmark" class="title">Cobbler自动化批量部署系统</a>
					<div>
						1.采用yum epel源安装 Cobbler .dhcp.httpd等服务及相关依赖包 [[email protected] ~]# wget -c http://dl.fedoraproject. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moml5x3.html" rel="bookmark" class="title">多重异常的时候要注意的一些问题</a>
					<div>
						1 package exception; 2 3 import java.util.InputMismatchException; 4 import java.util.Scanner; 5 6 pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mwNY0.html" rel="bookmark" class="title">主函数main中变量&lpar;int argc&comma;char &ast;argv&lbrack; &rsqb;&rpar;的含义</a>
					<div>
						在OpenCV上看到一段处理视频的代码,但是复制到VS下运行运行框总是闪退,查了一下原来应该直接在命令下运行exe文件,主要涉及main函数中argc和argv参数的意义,在这里说一下 argc: 整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrOqk3.html" rel="bookmark" class="title">循环控制</a>
					<div>
						  循环控制 1. 循环: 反复不停的做同1件事情. a. 现实生活中的循环在反复不停的做什么事情? b. 现实生活中的循环一定会有停止的那1刻.  2. 在代码中.我们会有这样的需求: 同1段代码反 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LGVW3.html" rel="bookmark" class="title">前端开源项目周报1226</a>
					<div>
						由OpenDigg 出品的前端开源项目周报第三期来啦.我们的前端开源周报集合了OpenDigg一周来新收录的优质的前端开发方面的开源项目,方便前端开发人员便捷的找到自己需要的项目工具等. Cost o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZ6AP3.html" rel="bookmark" class="title">JavaEE Tutorials &lpar;26&rpar; - 批处理</a>
					<div>
						26.1批处理介绍391 26.1.1批处理作业中的步骤391 26.1.2并行处理392 26.1.3状态和判定元素392 26.1.4批处理框架功能39326.2Java EE中的批处理394 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rn8PY0.html" rel="bookmark" class="title">POI教程之第一讲：创建新工作簿， Sheet 页，创建单元格</a>
					<div>
						第一讲 Poi 简介 Apache POI 是Apache 软件基金会的开放源码函数库,Poi提供API给java程序对Microsoft Office格式档案读和写的功能. 1.创建新工作簿,并给工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAdvb3.html" rel="bookmark" class="title">JVM 关闭前执行命令的钩子</a>
					<div>
						Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() { public void run() { System.out.prin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azbLJ3.html" rel="bookmark" class="title">关于浏览器的内存泄露</a>
					<div>
						什么是内存泄露 内存泄露是指一块被分配的内存既不能使用,又不能回收,直到浏览器进程结束.在C++中,因为是手动管理内存,内存泄露是经常出现的事情.而现在流行的C#和Java等语言采用了自动垃圾回收方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNngL4.html" rel="bookmark" class="title">浅谈VBA</a>
					<div>
						VBA,全称Visual Basic for Applications,其中的一些专业性的解释可以自行搜索,这里就不一一介绍.半年以前,我是不知道VBA的,当我听到VBA的时候,我却迷糊了.VBA是什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpGpX4.html" rel="bookmark" class="title">awk 中 FS的用法</a>
					<div>
						在openwrt文件 ar71xx.sh中 查询设备类型时,有这么一句, machine=$(awk 'BEGIN{FS=&quot;[ \t]+:[ \t]&quot;} /machine/ {pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgLPy3.html" rel="bookmark" class="title">第一阶段冲刺项目总结</a>
					<div>
						在5月14号,我们团队完成了第一阶段冲刺.现在已经过去一个多月,在回过头来看当时的冲刺仍旧有不如意的地方. 我们计划在第一阶段完成手电筒的基本设置,即可以在手机apk中能够运行程序,且实现闪光灯的调用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNXNm0.html" rel="bookmark" class="title">用MyEclipse自带工具生成WebService客户端代码</a>
					<div>
						本文章主要是介绍如何利用已经发布了的Webservice的wsdl来自动生成java的客户端代码.注意:本方法需要你采用的java版本是1.5或者以上的版本,采用MyEclipse来自动生成代码. w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQ1JPM.html" rel="bookmark" class="title">Ubiquitous Religions-并查集（5）</a>
					<div>
						Description There are so many different religions in the world today that it is difficult to keep tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nbJmP0.html" rel="bookmark" class="title">DOM 扩展</a>
					<div>
						1. 呈现模式 document.compatMode == &quot;CSS1Compat&quot;; 标准模式 document.compatMode == &quot;BackCompat& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
